local B = CBW_Battle

local spawnspheres = function(mthing,doublerespawn)

		if mthing.z == 0 then
			mthing.z = 15
		end
		local spawnx = mthing.x*FRACUNIT
		local spawny = mthing.y*FRACUNIT
		local subsec = R_PointInSubsector(spawnx, spawny)
		local spawnhight = (subsec.sector.floorheight+(mthing.z*FRACUNIT))
		local spheres = P_SpawnMobj(spawnx, spawny, spawnhight, MT_BATTLE_SPHERE)
		//spheres.scale = mthing.scale
		spheres.info.mass = 30*TICRATE
		if doublerespawn then
			spheres.info.mass = 120*TICRATE
		end
end

addHook("MapLoad", function(map)
	local weaponpannel = 0
	local bubblespawn = true
	// add chack for survival
	if gametyperules&GTR_LIVES then return end
	if gametyperules&GTR_POINTLIMIT then
		for mthing in mapthings.iterate do
			if mthing.type >= 330 and mthing.type <= 335 then
				weaponpannel = 1
				spawnspheres(mthing,false)
			end
			if weaponpannel <= 0 and mthing.type == 3630 then
				spawnspheres(mthing,false)
				weaponpannel = -1
			end
		end
		if weaponpannel != 0 then return end
		for mthing in mapthings.iterate do
		if (weaponpannel == 0 or weaponpannel == 10) and mthing.type == 3640 then
				spawnspheres(mthing,false)
				weaponpannel = 10
		end
		if weaponpannel == 0 and mthing.type == 321 then // spawn on match emerlds as a last resort
				spawnspheres(mthing,true)
				bubblespawn = false
			end
		if bubblespawn and weaponpannel == 0
		and mthing.type >= 3502 and mthing.type <= 3516 then
				spawnspheres(mthing,false)
			end
		end
	end
end)

addHook("MobjSpawn", function(mo)
	mo.statecheck = 1
	local paper = 1
	if maptol&TOL_ERZ3 then
		mo.scale = $/2
	end
	for i = 0, 1 do
		mo.color = 1
		paper = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_BATTLE_SPHERE_PAPER)
		paper.tracer = mo
		local subtract = mo.scale/5
		paper.spriteyscale = $-subtract
		paper.spritexscale = $-subtract
		paper.spritexoffset = $+subtract
		paper.spriteyoffset = $+(subtract*23)
		if i == 1 then // angle orbit
			paper.orbit = 15*mo.scale/FRACUNIT
		else
			paper.orbit = -15*mo.scale/FRACUNIT
		end
		if i >= 1 then
				break
		end
	end
end,MT_BATTLE_SPHERE)

addHook("MobjThinker", function(mo)
	mo.angle = $+ANG10
	if mo.statecheck == mo.state then return
	else
	mo.statecheck = mo.state
	end
	
	if mo.color == 112 then
		mo.color = 1
	else
		mo.color = min($+1,112)
	end
end,MT_BATTLE_SPHERE)

addHook("MobjDeath", function(mo,inf,sorce,dtype)
	mo.fuse = mo.info.mass
end,MT_BATTLE_SPHERE)

addHook("MobjFuse", function(mo)
	local respawn = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_BATTLE_SPHERE)
	respawn.scale = $/2
end,MT_BATTLE_SPHERE)

addHook("TouchSpecial", function(special,mo)
	mo.player.battlesphere = $+15
	special.destscale = $*2
	S_StartSound(special, sfx_s3k65 )
end,MT_BATTLE_SPHERE)

addHook("MobjThinker", function(mo)
	if mo.tracer and mo.tracer.valid then
	local tracer = mo.tracer
	P_MoveOrigin(mo,tracer.x - mo.orbit * cos(tracer.angle),
	tracer.y - mo.orbit * sin(tracer.angle), tracer.z)
	mo.angle = R_PointToAngle2(mo.x, mo.y, tracer.x, tracer.y)
	mo.angle = $+ANGLE_90
		if tracer.color then
		mo.color = tracer.color
		end
	if mo.tracer.state == S_BATTLE_SPHERE_END then
	 P_RemoveMobj(mo)
	return end
	else
	P_RemoveMobj(mo)
	end
end,MT_BATTLE_SPHERE_PAPER)